extends Node2D

var inHitbox = false

@onready var candleFlameTree = $"Candle-Base-Sprite/Flame-Tree"
@onready var candleFlameStateMachine = candleFlameTree.get("parameters/playback")

@onready var candleLightTree = $"Light-Tree"
@onready var candleLightStateMachine = candleLightTree.get("parameters/playback")

var flameOn = true

func _process(delta):
	if(Input.is_action_just_pressed("mouse-left-click") && inHitbox):
		toggleFlame()
		
func toggleFlame():
	if(flameOn):
		candleFlameStateMachine.travel("Flame-Blow-Out")
		candleLightStateMachine.travel("Light-Blow-Out")
	else:
		candleFlameStateMachine.start("Flame-Ignite")
		candleLightStateMachine.start("Light-Ignite")
	flameOn = !flameOn
	TripTySignalBus.emit_signal("clickCandle")
	
func playIgniteClip():
	TripTyAudioStreamHolder.playFireIgnite()

func _on_candle_hitbox_mouse_entered():
	inHitbox = true

func _on_candle_hitbox_mouse_exited():
	inHitbox = false

