extends Node2D

@export var sceneToLoad = "res://Triple-Tyrant/TripTy-Scenes/Transition-Thank-You-Message-Scene.tscn"
@onready var splashPlayer = $"Spalsh-Player"
@onready var splashTimer = $"Splash-Timer"
@onready var splashFlameStateMachine = $"Splash-Candle/Candle-Base-Sprite/Flame-Tree".get("parameters/playback")
@onready var splashLightStateMachine = $"Splash-Candle/Light-Tree".get("parameters/playback")

var clicked = false

func _ready():
	if(TripTyAudioStreamHolder.curSong != "title"):
		TripTyAudioStreamHolder.get_node(".").playtitleTheme()
	splashPlayer.play("Splash-Fade-In")
	splashTimer.start()
	splashFlameStateMachine.stop()
	splashLightStateMachine.stop()
	$"Splash-Candle/Candle-Light-Sprite".frame = 7
	$"Splash-Candle/Candle-Base-Sprite/Candle-Flame-Sprite".frame = 13
	
func _process(delta):
	if((Input.is_action_just_pressed("mouse-left-click") || Input.is_action_just_pressed("ui_accept")) && !clicked):
		splashPlayer.play("Splash-Fade-Out")
		clicked = true
	
func igniteCandle():
	splashFlameStateMachine.start("Flame-Ignite")	
	splashLightStateMachine.start("Light-Ignite")
	
func blowOutCandle():
		splashFlameStateMachine.start("Flame-Blow-Out")	
		splashLightStateMachine.start("Light-Blow-Out")
	
func playIgniteClip():
	TripTyAudioStreamHolder.playFireIgnite()	
	
func loadNextScene():
	TransitionManager.transitionClose(sceneToLoad, false)
	
func _on_splash_timer_timeout():
	splashPlayer.play("Splash-Fade-Out")
