extends Node2D


@onready var darkMask0 = preload("res://Triple-Tyrant/TripTy-Art/TTS-Game-Room-Dark-Mask-0.png")
@onready var darkMask1 = preload("res://Triple-Tyrant/TripTy-Art/TTS-Game-Room-Dark-Mask-1.png")
@onready var darkMask2 = preload("res://Triple-Tyrant/TripTy-Art/TTS-Game-Room-Dark-Mask-2.png")
@onready var darkMask3 = preload("res://Triple-Tyrant/TripTy-Art/TTS-Game-Room-Dark-Mask-3.png")

@onready var darkMaskSprite = $"Dark-Mask-Sprite" 

@onready var candles = $Candles.get_children()
@onready var numCandlesActive = candles.size()

var vagEnabled = false
var analEnabled = false
var oralEnabled = false

@onready var vagBtn = $"HUD-Layer/Vag-Btn"
@onready var oralBtn = $"HUD-Layer/Oral-Btn"
@onready var analBtn = $"HUD-Layer/Anal-Btn"

@onready var idleBtn = $"HUD-Layer/Idle-Btn"
@onready var slowBtn = $"HUD-Layer/Slow-Btn"
@onready var fastBtn = $"HUD-Layer/Fast-Btn"
@onready var cumBtn = $"HUD-Layer/Cum-Btn"

@onready var teraTree = $"Tera-Tree"
@onready var teraStateMachine = teraTree.get("parameters/playback")

@onready var bonusCircle = $"Bonus-Circle"
@onready var bonusScenePauseNode = $"Bonus-Scene-Canvas"
@onready var bonusSceneCanvas = $"Bonus-Scene-Canvas/ParallaxBackground"
@onready var bonusDemonPlayer = $"Bonus-Scene-Canvas/Demon-Intro-CanvasLayer/Bonus-Demon-Player"
@onready var bonusSuckStateMachine = $"Bonus-Scene-Canvas/Bonus-Suck-Tree".get("parameters/playback")

var currentSpeed = "Idle"

#@onready var voiceAudioStreamPlayer = $"Voice-Audio-Stream-Player"
#var lastVocieClipNum = 0

#@onready var moanMouthOpenSoftVoiceClips = [
	#preload("res://Triple-Tyrant/TripTy-SFX/TripTy-Voice-Clips/Moan Mouth Open Soft/Moan Mouth Open Soft-0.wav"),
	#preload("res://Triple-Tyrant/TripTy-SFX/TripTy-Voice-Clips/Moan Mouth Open Soft/Moan Mouth Open Soft-1.wav"),
	#preload("res://Triple-Tyrant/TripTy-SFX/TripTy-Voice-Clips/Moan Mouth Open Soft/Moan Mouth Open Soft-2.wav"),
	#preload("res://Triple-Tyrant/TripTy-SFX/TripTy-Voice-Clips/Moan Mouth Open Soft/Moan Mouth Open Soft-3.wav"),
	#preload("res://Triple-Tyrant/TripTy-SFX/TripTy-Voice-Clips/Moan Mouth Open Soft/Moan Mouth Open Soft-4.wav"),
	#preload("res://Triple-Tyrant/TripTy-SFX/TripTy-Voice-Clips/Moan Mouth Open Soft/Moan Mouth Open Soft-5.wav"),
	#preload("res://Triple-Tyrant/TripTy-SFX/TripTy-Voice-Clips/Moan Mouth Open Soft/Moan Mouth Open Soft-6.wav"),
	#preload("res://Triple-Tyrant/TripTy-SFX/TripTy-Voice-Clips/Moan Mouth Open Soft/Moan Mouth Open Soft-7.wav"),
	#preload("res://Triple-Tyrant/TripTy-SFX/TripTy-Voice-Clips/Moan Mouth Open Soft/Moan Mouth Open Soft-8.wav"),
	#preload("res://Triple-Tyrant/TripTy-SFX/TripTy-Voice-Clips/Moan Mouth Open Soft/Moan Mouth Open Soft-9.wav"),
	#preload("res://Triple-Tyrant/TripTy-SFX/TripTy-Voice-Clips/Moan Mouth Open Soft/Moan Mouth Open Soft-10.wav"),]

@onready var anySexBtnsActive = true

func _ready():
	TripTyAudioStreamHolder.get_node(".").playBedRoomTheme()
	TripTySignalBus.connect("clickCandle", Callable(self, "updateActiveCandles"))
	vagBtn.button_pressed = true
	teraStateMachine.start("Tera-Idle")
	bonusScenePauseNode.process_mode = ProcessMode.PROCESS_MODE_DISABLED

func updateActiveCandles():
	var cands = 0
	for flame in candles:
		if(flame.flameOn):
			cands += 1
	numCandlesActive = cands
	changeDarkMask()
	if(numCandlesActive == 0):
		toggleCircle(true)
	else:
		toggleCircle(false)
		
func activateAllCandles():
	for flame in candles:
		flame.flameOn = false
		flame.toggleFlame()
	numCandlesActive = 3
	changeDarkMask()
	
func changeDarkMask():
	if(numCandlesActive >= 3):
		darkMaskSprite.texture = darkMask0
	elif(numCandlesActive == 2):
		darkMaskSprite.texture  = darkMask1
	elif(numCandlesActive == 1):
		darkMaskSprite.texture  = darkMask2
	else:
		darkMaskSprite.texture  = darkMask3

func unToggleOtherMenuBtns():
	idleBtn.button_pressed = false
	slowBtn.button_pressed = false
	fastBtn.button_pressed = false
	cumBtn.button_pressed = false
	
func checkDicksActive():
	if(!vagEnabled && !analEnabled && !oralEnabled):
		print("no buttons active")
		anySexBtnsActive = false
		teraStateMachine.travel("Tera-Idle")
		unToggleOtherMenuBtns()
	else:
		anySexBtnsActive = true

func playRandomMoanMouthOpenSoftVoice():
	TripTyAudioStreamHolder.playRandomMoanMouthOpenSoftVoice()
	
func playRandomMoanTeethGritHardVoice():
	TripTyAudioStreamHolder.playRandomMoanTeethGritHardVoice()
	
func playRandomBreatheSFX():
	TripTyAudioStreamHolder.playRandomBreatheSFX()
	
func playRandomOralMoanSoftSFX():
	TripTyAudioStreamHolder.playRandomOralMoanSoftSFX()
	
func playRandomOralMoanHardSFX():
	TripTyAudioStreamHolder.playRandomOralMoanHardSFX()
	
func playRandSexSFX():
	TripTyAudioStreamHolder.playRandomSexSFX()
	
func playRandCumSFX():
	TripTyAudioStreamHolder.playRandomCumSFX()
	
func playRandPopSFX():
	TripTyAudioStreamHolder.playRandPop()
	
func playSlapSFX():
	TripTyAudioStreamHolder.playRandomSlapSFX()
	
func playRandOralDownSFX():
	TripTyAudioStreamHolder.playRandomOralDownSFX()

func playRandOralUpSFX():
	TripTyAudioStreamHolder.playRandomOralUpSFX()
	
# unused	
func chanceplayRandomMoanMouthOpenSoftVoice(chance):
	var randNum = randi_range(0,100)
	if(randNum < chance):
		print("play rand")
	playRandomMoanMouthOpenSoftVoice()
	
func resetAnimation():
	if(currentSpeed == "Idle"):
		goToIdleAnim()
	elif(currentSpeed == "Slow"):
		gotToSlowAnim()
	elif(currentSpeed == "Fast"):
		gotToFastAnim()
	elif(currentSpeed == "Cum"):
		goToCumAnim()

func goToIdleAnim():
	currentSpeed = "Idle"
	unToggleOtherMenuBtns()
	idleBtn.button_pressed = true
	teraStateMachine.travel("Tera-Idle")
	
func gotToSlowAnim():
	currentSpeed = "Slow"
	unToggleOtherMenuBtns()
	slowBtn.button_pressed = true
	if(anySexBtnsActive == false):
		print("no sex buttons")
		vagBtn.button_pressed = true
		teraStateMachine.travel("Tera-Vag-Slow")
	elif(vagEnabled && analEnabled && oralEnabled):
		teraStateMachine.travel("Tera-Triple-Slow")
	elif(analEnabled && oralEnabled):
		teraStateMachine.travel("Tera-Anal-Oral-Slow")
	elif(vagEnabled && oralEnabled):
		teraStateMachine.travel("Tera-Vag-Oral-Slow")
	elif(vagEnabled && analEnabled):
		teraStateMachine.travel("Tera-Vag-Anal-Slow")
	elif(oralEnabled):
		teraStateMachine.travel("Tera-Oral-Slow")
	elif(vagEnabled):
		teraStateMachine.travel("Tera-Vag-Slow")
	elif(analEnabled):
		teraStateMachine.travel("Tera-Anal-Slow")

func gotToFastAnim():
	currentSpeed = "Fast"
	unToggleOtherMenuBtns()
	fastBtn.button_pressed = true
	if(anySexBtnsActive == false):
		vagBtn.button_pressed = true
		teraStateMachine.travel("Tera-Vag-Fast")
	elif(vagEnabled && analEnabled && oralEnabled):
		teraStateMachine.travel("Tera-Triple-Fast")
	elif(analEnabled && oralEnabled):
		teraStateMachine.travel("Tera-Anal-Oral-Fast")
	elif(vagEnabled && oralEnabled):
		teraStateMachine.travel("Tera-Vag-Oral-Fast")
	elif(vagEnabled && analEnabled):
		teraStateMachine.travel("Tera-Vag-Anal-Fast")
	elif(oralEnabled):
		teraStateMachine.travel("Tera-Oral-Fast")
	elif(vagEnabled):
		teraStateMachine.travel("Tera-Vag-Fast")
	elif(analEnabled):
		teraStateMachine.travel("Tera-Anal-Fast")
		
func goToCumAnim():
	currentSpeed = "Cum"
	unToggleOtherMenuBtns()
	cumBtn.button_pressed = true
	if(anySexBtnsActive == false):
		vagBtn.button_pressed = true
		teraStateMachine.travel("Tera-Vag-Cum")
	elif(vagEnabled && analEnabled && oralEnabled):
		teraStateMachine.travel("Tera-Triple-Cum")
	elif(analEnabled && oralEnabled):
		teraStateMachine.travel("Tera-Anal-Oral-Cum")
	elif(vagEnabled && oralEnabled):
		teraStateMachine.travel("Tera-Vag-Oral-Cum")
	elif(vagEnabled && analEnabled):
		teraStateMachine.travel("Tera-Vag-Anal-Cum")
	elif(oralEnabled):
		teraStateMachine.travel("Tera-Oral-Cum")
	elif(vagEnabled):
		teraStateMachine.travel("Tera-Vag-Cum")
	elif(analEnabled):
		teraStateMachine.travel("Tera-Anal-Cum")

func _on_oral_btn_toggled(toggled_on):
	oralEnabled = toggled_on
	checkDicksActive()
	resetAnimation()
	
func _on_vag_btn_toggled(toggled_on):	
	vagEnabled = toggled_on
	checkDicksActive()
	resetAnimation()

func _on_anal_btn_toggled(toggled_on):
	analEnabled = toggled_on
	checkDicksActive()
	resetAnimation()

func _on_idle_btn_pressed():
	goToIdleAnim()

func _on_slow_btn_pressed():
	gotToSlowAnim()

func _on_fast_btn_pressed():
	gotToFastAnim()

func _on_cum_btn_pressed():
	goToCumAnim()

func _on_sign_btn_button_up():
	TripTyTeraPauseCanvasScene.clickedCredits = true
	TripTyTeraPauseCanvasScene.togglePauseMenu()

###############################################################

func toggleCircle(val):
	bonusCircle.visible = val
	
func toggleButtons(val):
	vagBtn.visible = val
	oralBtn.visible = val
	analBtn.visible = val
	idleBtn.visible = val
	slowBtn.visible = val
	fastBtn.visible = val
	cumBtn.visible = val

func toggleBonusCanvas(val):
	toggleButtons(!val)
	if(val):
		bonusDemonPlayer.play("Bonus-Demon-Summon")
		bonusSuckStateMachine.travel("Tera-Suck-Idle")
	else:
		bonusSceneCanvas.visible = val
	
	get_tree().paused = val
	if(val):
		bonusScenePauseNode.process_mode = ProcessMode.PROCESS_MODE_ALWAYS
	else:
		bonusScenePauseNode.process_mode = ProcessMode.PROCESS_MODE_DISABLED

func _on_bonus_circle_input_event(viewport, event, shape_idx):
	if(event is InputEventMouseButton && event.pressed):
		toggleBonusCanvas(true)


func _on_back_btn_button_up():
	toggleBonusCanvas(false)
	activateAllCandles()

func _on_config_btn_button_up():
	TripTyTeraPauseCanvasScene.togglePauseMenu()
