extends Node2D

const mainScenePath = "res://Triple-Tyrant/TripTy-Scenes/TripTy-Tera-Main-Scene.tscn"
@onready var pressStartPlayer = $"Press-Start-Player"
@onready var teraTitlePlayer = $"Tera-Title-Player"
@onready var teraSprite = $"Tera-Sprite"
@onready var teraSpriteNorm = preload("res://Triple-Tyrant/TripTy-Art/Title/TTS-Game-Title-Tera-Sheet.png")
@onready var teraSpriteEating = preload("res://Triple-Tyrant/TripTy-Art/Title/TTS-Game-Title-Tera-Eating-Sheet.png")
var isEating = false
var pressStartClicked = false

func _ready():
	if(TripTyAudioStreamHolder.curSong != "title"):
		TripTyAudioStreamHolder.get_node(".").playtitleTheme()

func _process(delta):
	pass
	if(Input.is_action_just_pressed("ui_accept")):
		pressStartPlayer.play("Press-Start-Pressed")
	#if(Input.is_action_just_pressed("mouse-left-click") || Input.is_action_just_pressed("ui_accept")):
	#	pressStartPlayer.play("Press-Start-Pressed")

func loadMainScene():
	TransitionManager.transitionClose(mainScenePath, false)
	#get_tree().change_scene_to_file(mainScenePath)
	
func playRandomMoanMouthOpenSoftVoice():
	if(isEating):
		TripTyAudioStreamHolder.get_node(".").playRandomMoanMouthOpenSoftVoice()
		
func playRandSexSFX():
	if(isEating):
		TripTyAudioStreamHolder.playRandomSexSFX()

func _on_title_bonus_btn_button_up():
	if(!isEating):
		isEating = true
		teraSprite.texture = teraSpriteEating
	else:
		isEating = false
		teraSprite.texture = teraSpriteNorm

func _on_press_start_btn_button_down():
	pressStartPlayer.play("Press-Start-Pressed")
	#print("pressed")


func _on_press_start_input_event(viewport, event, shape_idx):
	if(event is InputEventMouseButton && event.pressed && !pressStartClicked):
		pressStartClicked = true
		pressStartPlayer.play("Press-Start-Pressed")
		#print("pressed")

func _on_sign_btn_button_down():
	TripTyTeraPauseCanvasScene.clickedCredits = true
	TripTyTeraPauseCanvasScene.togglePauseMenu()
